#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <malloc.h>
#include <ctype.h>
#include <assert.h>

char* inputfile = "images.txt";
char* outputfile = "shit.txt";
char* outputfile2 = "shitgrid.txt";
int numOfImages = 76;
int count;

struct node;
typedef struct node {
	int  nsfw;
	char link[2048];
	char direct[2048];
	char author[64];
	int type;
} node;

struct node* create_node(FILE *fp)
{
	char numtemp[10];
	char a[2048];
	char b[2048];
	int c;
	char d[64];
	int e;

	fscanf(fp,"%s", numtemp);
	c = atoi(numtemp);
	fscanf(fp,"%s", a);
	fscanf(fp,"%s", b);
	fscanf(fp,"%s", d);
	fscanf(fp,"%s", numtemp);
	e = atoi(numtemp);

	struct node *node = malloc(sizeof(struct node));
	if (node == NULL)
	{
		printf("not enough memory for node\n\n");
		exit(1);
	}
	strcpy(node->link, a);
	strcpy(node->direct, b);
	strcpy(node->author, d);
	node->nsfw = c;
	node->type = e;

	return(node);
}

int main(int argc, char* argv[]) 
{
	FILE* ifp;
	FILE* ofp;
	FILE* gfp;

	ifp	=	fopen(inputfile, "r");
	
	if(ifp == NULL) {
		printf("Input file could not be opened.\n");
		exit(1);
	}

	ofp = 	fopen(outputfile, "w");
	gfp = 	fopen(outputfile2, "w");
	
	struct node* image 	= create_node(ifp);

	//before loops

	fprintf(ofp, "<div class=\"row\">\n\t<div class=\"column\">");
	fprintf(gfp, "<center>\n\t<div class=\"container\">");

	while(!feof(ifp)) 
	{
		// reg print
		printf("\n%s, %s", image->link, image->direct);
		// -----
		if(count == (numOfImages/2)) {
			fprintf(ofp, "\n\t</div>\n\t<div class=\"column\">");
			++count;
		} else {
			++count;
		}
		//reg view
		if(image->type == 0) {	//is image
			if(image->nsfw == 0) {
				//reg view
				fprintf(ofp, "\n\t\t<a href = \"%s\" title = \"@%s\">\n\t\t\t<div id = \"imagebox\">\n\t\t\t\t<img src = \"%s\">\n\t\t\t</div>\n\t\t</a>", image->link, image->author, image->direct);

				//grid view
				fprintf(gfp, "\n\t\t<a href = \"%s\" title = \"@%s\">\n\t\t\t<div id = \"imagebox\">\n\t\t\t\t<img src = \"%s\">\n\t\t\t</div>\n\t\t</a>", image->link, image->author, image->direct);
			} else {	//is nsfw image
				//reg view
				fprintf(ofp, "\n\t\t<a href = \"%s\" title = \"@%s\">\n\t\t\t<div id = \"imagebox\">\n\t\t\t\t<div class = \"tag\"><img src = \"./nsfw.png\"></div>\n\t\t\t\t<div class = \"nsfw\">\n\t\t\t\t\t<img src = \"%s\">\n\t\t\t\t</div>\n\t\t\t</div>\n\t\t</a>", image->link, image->author, image->direct);

				//grid view
				fprintf(gfp, "\n\t\t<a href = \"%s\" title = \"@%s\">\n\t\t\t<div id = \"imagebox\">\n\t\t\t\t<div class = \"tag\"><img src = \"./nsfw.png\"></div>\n\t\t\t\t<div class = \"nsfw\">\n\t\t\t\t\t<img src = \"%s\">\n\t\t\t\t</div>\n\t\t\t</div>\n\t\t</a>", image->link, image->author, image->direct);
			}
		} else {	//is video
			//reg view
			fprintf(ofp, "\n\t\t<a href = \"%s\" title = \"@%s\">\n\t\t\t<div id = \"imagebox\">\n\t\t\t\t<video autoplay controls loop>\n\t\t\t\t\t<source src = \"%s\" type = \"video/mp4\">\n\t\t\t\t</video>\n\t\t\t</div>\n\t\t</a>", image->link, image->author, image->direct);

			//grid view
			fprintf(gfp, "\n\t\t<a href = \"%s\" title = \"@%s\">\n\t\t\t<div id = \"imagebox\">\n\t\t\t\t<video autoplay controls loop>\n\t\t\t\t\t<source src = \"%s\" type = \"video/mp4\">\n\t\t\t\t</video>\n\t\t\t</div>\n\t\t</a>", image->link, image->author, image->direct);
		}

		free(image);

		if(!feof(ifp)) {
			image = create_node(ifp);
		} else {
			break;
		}
	}

	//after loops
	fprintf(ofp, "\n\t</div>\n</div>");
	fprintf(gfp, "\n\t</div>\n</center>");

	fclose(ifp);
	fclose(ofp);
	fclose(gfp);

}